<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcNeuralNet Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcNeuralNet Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcNeuralNet" --><!-- doxytag: inherits="iBase" -->
<p>A property class implementing a feed-forward neural network.  
 <a href="structiPcNeuralNet.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="neuralnet_8h_source.html">propclass/neuralnet.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcNeuralNet:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcNeuralNet.png" usemap="#iPcNeuralNet_map" alt=""/>
  <map id="iPcNeuralNet_map" name="iPcNeuralNet_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,87,24"/>
</map>
 </div></div>

<p><a href="structiPcNeuralNet-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a7b08a79cdc66cf374f67814d66e5ed14">CacheWeights</a> (const char *scope, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> id) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Saves the weightings to cache with an <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCacheManager.html">iCacheManager</a>.  <a href="#a7b08a79cdc66cf374f67814d66e5ed14"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiCelNNWeights.html">iCelNNWeights</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a56597977382b31f14a956d0448481776">CreateEmptyWeights</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a new weights structure with the same size as the current one.  <a href="#a56597977382b31f14a956d0448481776"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="structcelData.html">celData</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a93498479e05f79c9bc80fb5260600e20">GetOutput</a> (size_t index) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the value of one of the outputs.  <a href="#a93498479e05f79c9bc80fb5260600e20"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelData.html">celData</a> &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a40709c857a4f769d52bd5886aab5cec3">GetOutputs</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieves all the output values in one go.  <a href="#a40709c857a4f769d52bd5886aab5cec3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a98a30b06e65a05355645c6d80dab7944">GetWeights</a> (<a class="el" href="structiCelNNWeights.html">iCelNNWeights</a> *out) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copies the weightings of the neural network into the structure provided.  <a href="#a98a30b06e65a05355645c6d80dab7944"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a812e20c1b378a6f28c5cf54807ad5516">LoadCachedWeights</a> (const char *scope, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads the weightings from cache with an <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCacheManager.html">iCacheManager</a>.  <a href="#a812e20c1b378a6f28c5cf54807ad5516"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a1f0fb6bad9d6ec726e9a14cc9e817a55">Process</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Runs one iteration through the network, reading the inputs and setting the outputs.  <a href="#a1f0fb6bad9d6ec726e9a14cc9e817a55"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a3ea5bf4ad84cf46b611c0f7ec68f6a87">SetActivationFunc</a> (<a class="el" href="classcelNNActivationFunc.html">celNNActivationFunc</a> *)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the activation function of the neural network.  <a href="#a3ea5bf4ad84cf46b611c0f7ec68f6a87"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a244ce5d34b7b4e4185777defa71eefc0">SetComplexity</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the heuristic that will be used to set the sizes of each layer.  <a href="#a244ce5d34b7b4e4185777defa71eefc0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#aaef26b7ad64b6ffaf33a73b8e5715962">SetInput</a> (size_t index, const <a class="el" href="structcelData.html">celData</a> &amp;value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the value of one of the inputs.  <a href="#aaef26b7ad64b6ffaf33a73b8e5715962"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#ac7325112d5db4779b6142e368a9298f0">SetInputs</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelData.html">celData</a> &gt; &amp;values)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets all the input values in one go.  <a href="#ac7325112d5db4779b6142e368a9298f0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a089dd8c8c13da27211bfbf60c55196b1">SetLayerSizes</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; size_t &gt; &amp;sizes)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manually set the number of nodes in each hidden layer.  <a href="#a089dd8c8c13da27211bfbf60c55196b1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a0f931a2f212e050df968fb68b623dbc9">SetSize</a> (size_t inputs, size_t outputs, size_t layers)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the size of the neural network (number of inputs, outputs and hidden layers).  <a href="#a0f931a2f212e050df968fb68b623dbc9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#ac3ec5813085cc15644722545071edf2c">SetWeights</a> (const <a class="el" href="structiCelNNWeights.html">iCelNNWeights</a> *in)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copies the weightings into the neural network from the given structure.  <a href="#ac3ec5813085cc15644722545071edf2c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNeuralNet.html#a64142c300a25cddb5d8ab688e2e6e805">Validate</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if the neural network is initialized and ready to use.  <a href="#a64142c300a25cddb5d8ab688e2e6e805"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A property class implementing a feed-forward neural network. </p>
<p>The property class holds the following properties:</p>
<ul>
<li>"inputs" (long) The number of inputs in the neural network.</li>
<li>"outputs" (long) The number of outputs in the neural network.</li>
<li>"layers" (long) The number of hidden layers in the neural network.</li>
<li>"dispatch" (bool) If true, pcneuralnet_outputs messages will be sent.</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.neuralnet.action.' if you want to access this action through a message):</p>
<ul>
<li>"SetComplexity" Sets the method to use to set the sizes of the layers. Add prefix "cel.complexity." to the heuristic name to get the param.</li>
<li>"SetLayerSizes" Instead of SetComplexity, this sets the sizes of the layers manually. Parameters: "layer0"..."layerN" (longs).</li>
<li>"SetActivationFunc" Sets the activation function in the neural network. Parameter: "func" (string). See iCelNNActivationFunc and its subclasses. This also sets the datatype of the inputs and outputs.</li>
<li>"SetInputs" Sets the values of the inputs. Parameters: "input0"..."inputN" the values (N = "inputs" - 1).</li>
<li>"Process" Runs one iteration through the neural network, reading the inputs and setting the outputs. May send "pcneuralnet_outputs" message.</li>
<li>"SaveCache" Saves the weightings to VFS path /cellib/cache/pcneuralnet. Parameters: "scope" (string), "id" (long). See <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCacheManager.html">iCacheManager</a> in <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/namespaceCS.html">CS</a>.</li>
<li>"LoadCache" Loads the weightings from VFS path /cellib/cache/pcneuralnet. Parameters: "scope" (string), "id" (long). See <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCacheManager.html">iCacheManager</a> in <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/namespaceCS.html">CS</a>.</li>
</ul>
<p>And can send the following message to the behaviour:</p>
<ul>
<li>"pcneuralnet_outputs" Sent after every call to "Process". Parameters: "output0"..."outputN" the output values from the neural network (N - "outputs" - 1). </li>
</ul>

<p>Definition at line <a class="el" href="neuralnet_8h_source.html#l00095">95</a> of file <a class="el" href="neuralnet_8h_source.html">neuralnet.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a7b08a79cdc66cf374f67814d66e5ed14"></a><!-- doxytag: member="iPcNeuralNet::CacheWeights" ref="a7b08a79cdc66cf374f67814d66e5ed14" args="(const char *scope, uint32 id) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNeuralNet.html#a7b08a79cdc66cf374f67814d66e5ed14">iPcNeuralNet::CacheWeights</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>scope</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Saves the weightings to cache with an <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCacheManager.html">iCacheManager</a>. </p>

</div>
</div>
<a class="anchor" id="a56597977382b31f14a956d0448481776"></a><!-- doxytag: member="iPcNeuralNet::CreateEmptyWeights" ref="a56597977382b31f14a956d0448481776" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiCelNNWeights.html">iCelNNWeights</a>&gt; <a class="el" href="structiPcNeuralNet.html#a56597977382b31f14a956d0448481776">iPcNeuralNet::CreateEmptyWeights</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a new weights structure with the same size as the current one. </p>

</div>
</div>
<a class="anchor" id="a93498479e05f79c9bc80fb5260600e20"></a><!-- doxytag: member="iPcNeuralNet::GetOutput" ref="a93498479e05f79c9bc80fb5260600e20" args="(size_t index) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="structcelData.html">celData</a>&amp; <a class="el" href="structiPcNeuralNet.html#a93498479e05f79c9bc80fb5260600e20">iPcNeuralNet::GetOutput</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the value of one of the outputs. </p>

</div>
</div>
<a class="anchor" id="a40709c857a4f769d52bd5886aab5cec3"></a><!-- doxytag: member="iPcNeuralNet::GetOutputs" ref="a40709c857a4f769d52bd5886aab5cec3" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt;<a class="el" href="structcelData.html">celData</a>&gt;&amp; <a class="el" href="structiPcNeuralNet.html#a40709c857a4f769d52bd5886aab5cec3">iPcNeuralNet::GetOutputs</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Retrieves all the output values in one go. </p>

</div>
</div>
<a class="anchor" id="a98a30b06e65a05355645c6d80dab7944"></a><!-- doxytag: member="iPcNeuralNet::GetWeights" ref="a98a30b06e65a05355645c6d80dab7944" args="(iCelNNWeights *out) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#a98a30b06e65a05355645c6d80dab7944">iPcNeuralNet::GetWeights</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelNNWeights.html">iCelNNWeights</a> *&#160;</td>
          <td class="paramname"><em>out</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copies the weightings of the neural network into the structure provided. </p>

</div>
</div>
<a class="anchor" id="a812e20c1b378a6f28c5cf54807ad5516"></a><!-- doxytag: member="iPcNeuralNet::LoadCachedWeights" ref="a812e20c1b378a6f28c5cf54807ad5516" args="(const char *scope, uint32 id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNeuralNet.html#a812e20c1b378a6f28c5cf54807ad5516">iPcNeuralNet::LoadCachedWeights</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>scope</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Loads the weightings from cache with an <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCacheManager.html">iCacheManager</a>. </p>

</div>
</div>
<a class="anchor" id="a1f0fb6bad9d6ec726e9a14cc9e817a55"></a><!-- doxytag: member="iPcNeuralNet::Process" ref="a1f0fb6bad9d6ec726e9a14cc9e817a55" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#a1f0fb6bad9d6ec726e9a14cc9e817a55">iPcNeuralNet::Process</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Runs one iteration through the network, reading the inputs and setting the outputs. </p>

</div>
</div>
<a class="anchor" id="a3ea5bf4ad84cf46b611c0f7ec68f6a87"></a><!-- doxytag: member="iPcNeuralNet::SetActivationFunc" ref="a3ea5bf4ad84cf46b611c0f7ec68f6a87" args="(celNNActivationFunc *)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#a3ea5bf4ad84cf46b611c0f7ec68f6a87">iPcNeuralNet::SetActivationFunc</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelNNActivationFunc.html">celNNActivationFunc</a> *&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the activation function of the neural network. </p>

</div>
</div>
<a class="anchor" id="a244ce5d34b7b4e4185777defa71eefc0"></a><!-- doxytag: member="iPcNeuralNet::SetComplexity" ref="a244ce5d34b7b4e4185777defa71eefc0" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#a244ce5d34b7b4e4185777defa71eefc0">iPcNeuralNet::SetComplexity</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the heuristic that will be used to set the sizes of each layer. </p>
<p>Alternatively you can call SetLayerSizes to set the sizes manually.</p>
<p>Acceptable values for the name parameter are:</p>
<ul>
<li>"linear" (default) sizes progress linearly from inputs to outputs.</li>
<li>"halfLinear" like linear but first layer is 50% of the number of inputs.</li>
<li>"addHalfLinear" line linear but first layer is 150% the number of inputs. </li>
</ul>

</div>
</div>
<a class="anchor" id="aaef26b7ad64b6ffaf33a73b8e5715962"></a><!-- doxytag: member="iPcNeuralNet::SetInput" ref="aaef26b7ad64b6ffaf33a73b8e5715962" args="(size_t index, const celData &amp;value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#aaef26b7ad64b6ffaf33a73b8e5715962">iPcNeuralNet::SetInput</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcelData.html">celData</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the value of one of the inputs. </p>

</div>
</div>
<a class="anchor" id="ac7325112d5db4779b6142e368a9298f0"></a><!-- doxytag: member="iPcNeuralNet::SetInputs" ref="ac7325112d5db4779b6142e368a9298f0" args="(const csArray&lt; celData &gt; &amp;values)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#ac7325112d5db4779b6142e368a9298f0">iPcNeuralNet::SetInputs</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelData.html">celData</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>values</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets all the input values in one go. </p>

</div>
</div>
<a class="anchor" id="a089dd8c8c13da27211bfbf60c55196b1"></a><!-- doxytag: member="iPcNeuralNet::SetLayerSizes" ref="a089dd8c8c13da27211bfbf60c55196b1" args="(const csArray&lt; size_t &gt; &amp;sizes)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#a089dd8c8c13da27211bfbf60c55196b1">iPcNeuralNet::SetLayerSizes</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; size_t &gt; &amp;&#160;</td>
          <td class="paramname"><em>sizes</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manually set the number of nodes in each hidden layer. </p>
<p>Alternatively you can call SetComplexity to have the sizes set automatically according to the selected heuristic. </p>

</div>
</div>
<a class="anchor" id="a0f931a2f212e050df968fb68b623dbc9"></a><!-- doxytag: member="iPcNeuralNet::SetSize" ref="a0f931a2f212e050df968fb68b623dbc9" args="(size_t inputs, size_t outputs, size_t layers)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNeuralNet.html#a0f931a2f212e050df968fb68b623dbc9">iPcNeuralNet::SetSize</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>inputs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>outputs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>layers</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the size of the neural network (number of inputs, outputs and hidden layers). </p>

</div>
</div>
<a class="anchor" id="ac3ec5813085cc15644722545071edf2c"></a><!-- doxytag: member="iPcNeuralNet::SetWeights" ref="ac3ec5813085cc15644722545071edf2c" args="(const iCelNNWeights *in)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNeuralNet.html#ac3ec5813085cc15644722545071edf2c">iPcNeuralNet::SetWeights</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structiCelNNWeights.html">iCelNNWeights</a> *&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copies the weightings into the neural network from the given structure. </p>

</div>
</div>
<a class="anchor" id="a64142c300a25cddb5d8ab688e2e6e805"></a><!-- doxytag: member="iPcNeuralNet::Validate" ref="a64142c300a25cddb5d8ab688e2e6e805" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNeuralNet.html#a64142c300a25cddb5d8ab688e2e6e805">iPcNeuralNet::Validate</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns true if the neural network is initialized and ready to use. </p>
<p>If it is not, then an attempt is made to initialize it, and the return value signifies success or failure of that attempt. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="neuralnet_8h_source.html">neuralnet.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
